﻿import { Component, Input, OnInit } from '@angular/core';
import { Rule } from '@app/ui/description/editor/description-form/visibility-rules/models/rule';
import { VisibilityRulesService } from '@app/ui/description/editor/description-form/visibility-rules/visibility-rules.service';


@Component({
	selector: 'app-final-preview-component',
	templateUrl: './final-preview.component.html',
	styleUrls: ['./final-preview.component.scss'],
	providers: [VisibilityRulesService]
})

export class FinalPreviewComponent implements OnInit {


	@Input() descriptionTempaltePersist = null;
	
	visibilityRules: Rule[] = [];
	@Input() formGroup = null;

	constructor(private visibilityRulesService: VisibilityRulesService) {

	}



	ngOnInit(): void {
		this.visibilityRulesService.buildVisibilityRules(this.visibilityRules, this.formGroup);
	}

}
